Index: generic_views.txt
===================================================================
--- generic_views.txt	(revision 4290)
+++ generic_views.txt	(working copy)
@@ -266,9 +266,9 @@
       the view's template. See the `RequestContext docs`_.
 
     * ``template_object_name``:  Designates the name of the template variable
-       to use in the template context. By default, this is ``'object'``. The
-       view will append ``'_list'`` to the value of this parameter in
-       determining the variable's name.
+      to use in the template context. By default, this is ``'object'``. The
+      view will append ``'_list'`` to the value of this parameter in
+      determining the variable's name.
 
     * ``make_object_list``: A boolean specifying whether to retrieve the full
       list of objects for this year and pass those to the template. If ``True``,
@@ -360,9 +360,9 @@
       the view's template. See the `RequestContext docs`_.
 
     * ``template_object_name``:  Designates the name of the template variable
-       to use in the template context. By default, this is ``'object'``. The
-       view will append ``'_list'`` to the value of this parameter in
-       determining the variable's name.
+      to use in the template context. By default, this is ``'object'``. The
+      view will append ``'_list'`` to the value of this parameter in
+      determining the variable's name.
 
     * ``mimetype``: The MIME type to use for the resulting document. Defaults
       to the value of the ``DEFAULT_CONTENT_TYPE`` setting.
@@ -441,9 +441,9 @@
       the view's template. See the `RequestContext docs`_.
 
     * ``template_object_name``:  Designates the name of the template variable
-       to use in the template context. By default, this is ``'object'``. The
-       view will append ``'_list'`` to the value of this parameter in
-       determining the variable's name.
+      to use in the template context. By default, this is ``'object'``. The
+      view will append ``'_list'`` to the value of this parameter in
+      determining the variable's name.
 
     * ``mimetype``: The MIME type to use for the resulting document. Defaults
       to the value of the ``DEFAULT_CONTENT_TYPE`` setting.
@@ -526,9 +526,9 @@
       the view's template. See the `RequestContext docs`_.
 
     * ``template_object_name``:  Designates the name of the template variable
-       to use in the template context. By default, this is ``'object'``. The
-       view will append ``'_list'`` to the value of this parameter in
-       determining the variable's name.
+      to use in the template context. By default, this is ``'object'``. The
+      view will append ``'_list'`` to the value of this parameter in
+      determining the variable's name.
 
     * ``mimetype``: The MIME type to use for the resulting document. Defaults
       to the value of the ``DEFAULT_CONTENT_TYPE`` setting.
@@ -710,9 +710,9 @@
       the view's template. See the `RequestContext docs`_.
 
     * ``template_object_name``:  Designates the name of the template variable
-       to use in the template context. By default, this is ``'object'``. The
-       view will append ``'_list'`` to the value of this parameter in
-       determining the variable's name.
+      to use in the template context. By default, this is ``'object'``. The
+      view will append ``'_list'`` to the value of this parameter in
+      determining the variable's name.
 
     * ``mimetype``: The MIME type to use for the resulting document. Defaults
       to the value of the ``DEFAULT_CONTENT_TYPE`` setting.
@@ -973,7 +973,7 @@
       the view's template. See the `RequestContext docs`_.
 
     * ``template_object_name``:  Designates the name of the template variable
-       to use in the template context. By default, this is ``'object'``.
+      to use in the template context. By default, this is ``'object'``.
 
 **Template name:**
 
@@ -1054,7 +1054,7 @@
       the view's template. See the `RequestContext docs`_.
 
     * ``template_object_name``:  Designates the name of the template variable
-       to use in the template context. By default, this is ``'object'``.
+      to use in the template context. By default, this is ``'object'``.
 
 **Template name:**
 